def gera_propriedade_tipo( nome, tipo, valida, errmsg ):
    attr = '__%s' % nome
    def get( self ):
        return getattr( self, attr )
    # get()

    def set( self, valor ):
        if isinstance( valor, tipo ):
            if valida( valor ):
                setattr( self, attr, valor )
            else:
                raise ValueError( errmsg )
        else:
            raise TypeError( errmsg )
    # set()

    return property( get, set )
# gera_propriedade_tipo()

def gera_propriedade_str( nome, tam_max ):
    def valida( valor ):
        return len( valor ) <= tam_max
    # valida()

    msg = ( '%s precisa ser "str" e ter ' \
            'menos que %s letras' ) % ( nome, tam_max )

    return gera_propriedade_tipo( nome, str, valida, msg )
# gera_propriedade_str()


def gera_propriedade_int( nome, min, max ):
    def valida( valor ):
        return min <= valor <= max
    # valida()

    msg = '%s precisa ser "int" entre %s e %s' % \
          ( nome, min, max )

    return gera_propriedade_tipo( nome, int, valida, msg )
# gera_propriedade_str()



class Pessoa( object ):
    nome  = gera_propriedade_str( "nome", 20 )
    rg    = gera_propriedade_str( "rg", 9 )
    idade = gera_propriedade_int( "idade", 1, 150 )


p = Pessoa()

p.nome = 10     # TypeError
p.nome = "Este texto tem mais de 20 letras" # ValueError
p.idade = "200" # TypeError
p.idade = 200   # ValueError

p.nome  = "Gustavo" # Ok!
p.idade = 22

